%File: Lessico.pl
% IA a.a. 2024-25
% R. Basili (University of Roma, Tor Vergata)
% Componente lessicale dell'analizzatore di frasi semplici in Italiano 
% Lessico
% Componente DIchiarativa delle proprietà lessicali delle parole
% Tipi di istanze lessicali:
% - Nomi e verbi di esempio 
% - Dizionario esteso della lingua italiana


%Lessico
% Nomi degli esempi N_EX()
n_ex(['Giovanna']).
n_ex(['Giovanni']).
n_ex(['Roma']).
n_ex([poema]).
n_ex([autori]).
n_ex([capitolo]).
n_ex([sezioni]).
n_ex([libro]).
n_ex(['Mario']).
n_ex([due]).
n_ex([notte]).
n_ex([ore]).
%NOMI, categoria generale dal dizionario N()
n([X]) :- n_ex([X]),!.
n([X]) :- word(X,_,n,_),!. 

% Verbi V()
%Verbi dagli Esempi V_EX()
v_ex([mangia]).
v_ex([erano]).
%v_ex([fu,scritto]).
v_ex([scorrevano]).
v_ex([scrisse]).
%v_ex([scritto]).
v_ex([abbandonassi]).
v_ex([discorreva]).
%Verbi Categoria Generale V()
v(X) :- v_ex(X),!.
v([X]) :- word(X,_,vt,_), !. %transitivi
v([X]) :- word(X,_,vti,_), !. %intransitivi

%Verbi al participio passato: PartPass
partpass([X]) :-  word(X,_,vtpp,_), !.

%Aggettivi AP()
ap_ex([noiose]).
ap_ex([prime]).
ap_ex([primo]).
ap_ex([insonni]).
ap_ex([due]).
ap([X]) :- ap_ex([X]),!.
ap([X]) :- word(X,_,adj,_), !.

%Aggettivi avverbiali ADVP()
adv([X]) :- word(X,_,avv,_), !.

%Articoli art()
art_ex([il]).
art_ex([le]).
art_ex([un]).
art([X]) :- art_ex([X]),!.
art([X]) :- word(X,_,art,_), !.

%preposizioni prep()
%prep_ex([da]).
%prep_ex([nella]).
%prep_ex([del]).
%prep_ex([a]).
%prep_ex([del]).
%prep_ex([di]).
%prep([X]) :- prep_ex([X]),!.
prep([X]) :- word(X,_,prep,_), !.

%pronomi clitici pron_cli()
pron_cli([X]) :- word(X,_,'pron.pers.cli.acc',_), !.


%Lessico generale dell'italiano (estratto)
word(a, a, prep, 'invariante').
word(abbagliati, abbagliare, vtpp, 'part.pass.mas.plur').
word(abbaglio, abbagliare, vt, '1.sing.ind.pres').
word(abbaglio, abbaglio, n, 'mas.sing').
word(abbandona, abbandonare, vt, '2.sing.imper.pres').
word(abbandona, abbandonare, vt, '3.sing.ind.pres').

%word(+Parola_target, -Lemma, -CG, -TrattiMorfologici)
%- Parola_target, che corrisponde al token del testo in ingresso
%- Lemma, Lemma di derivazione, forma canonica di una parola
%- CG, Categoria Grammaticale del token
%- TrattiMorfologici, proprietà morfologiche 
%   (persona, modo, tempo verbali) per i verbi 
%   (persona, genere, numero)  per le altre categorie