?- use_module(library(system)).
?- use_module(library(lists)).

%?-reconsult('LexiconItaliano.pl').
%
%?-reconsult('Grammatica.pl').
?-reconsult('MiniGrammatica_per_esercizio.pl').
?-reconsult('Lessico.pl').


% Frasi di Esempio sent/2
%
sent(0,['Mario',mangia]).
sent(1,['Giovanni',scrisse,un,poema]).
sent(2,[il,libro,fu,scritto,da,due,autori]).
sent(3,[le,prime,sezioni,erano,noiose]).
sent(4,[le,ore,insonni,scorrevano,nella,notte,a,'Roma']).
sent(5,['Giovanna',di,notte,discorreva,del,primo,capitolo,del,libro]).

%Analisi di una frase di esempio test/1
test(I) :- 
  sent(I,Frase),
  /* applicazione della Grammatica di s/2 all'input I-esimo */ findall( Tree, s(Frase,Tree), ListOfTrees),
  length(ListOfTrees,N),
  mostra_esempi(Frase,ListOfTrees, N),
  header.

mostra_esempi(Frase,_,0) :- 
  write('\n\nThe sentence: '), write(Frase), 
  write(' is not accepted.\n\n'),!.
mostra_esempi(Frase, ListOfTrees, N) :- 
  write('\n\nThe sentence: '), write(Frase), 
  write(' is accepted. \nThere are '),write(N),
  write(' Solutions:\n\n'),
  stampaAlberi(0,ListOfTrees),
  write(' Type <c.> and RETURN for the NEXT sentence >>> '),
  read(_).


%Analisi di una nuova frase in input test/0
test :-
	write('Write your sentence in the Prolog format for lists >>> '),nl,
	read(Frase),
	findall( Alb, s(Frase,Alb), ListDIAlberi),
	length(ListDIAlberi,N),
	mostra_esempi(Frase,ListDIAlberi, N),
	header.

stampaAlberi(_,[]).
stampaAlberi(N,[T|AltriAlberi]) :-
	write('----------------------------------------------------- \n '),write('Tree: '),write(N),nl,
	write(T),nl,
		write('----------------------------------------------------- \n '),nl,
	( AltriAlberi\==[],
	  write(' For the next tree, type <c.> and RETURN  >>> '), read(_)
	  ;
	  true ),
	NewN is N+1,
	!,
	stampaAlberi(NewN, AltriAlberi).

st_frase([]).
st_frase([A|Rest]) :-
	write(A),write(' '),
	!,
	st_frase(Rest).

quali_esempi :-
	nl,nl,nl,
	sent(N, Sent),
	write('['),write(N),write(']  '), st_frase(Sent), nl,
	fail.
quali_esempi :-nl,nl.

first_msg :- 
	write('To run the system on the above examples please type: \n'),
	write('  test(I)\n'), 
	write('where I is a valid example identifier \n '),
	write(' OR \n'),
	write('type simply \n'),
	write('  test\n'),
	write('to run a new sentence.\n\n').
	

print_t(A,_) :-
	is_list(A), write(A), %write(')---'),
	!.
print_t(A,Col) :-
  \+ is_list(A),
  print_tree(A,Col).
	
print_tree([], _) :-!.
print_tree(Tree,Col) :-
	Tree =..[FthNode | SonsList],
  nl,tab(Col),
	write(FthNode),write('('),
  NewCol is Col + 3 + 1,
	print_trees(SonsList, NewCol),
  nl,tab(Col),
	write(')'),
	!.


print_trees([], _).
print_trees([Tree|SonsList], Col) :-
	print_t(Tree,Col),
	!,
	print_trees(SonsList, Col).

	
minidict :-
	reconsult('MiniLexiconItaliano.pl'),
	header.
	
dict :-
	reconsult('LexiconItaliano.pl'),
	header.
	
header :- 
  	write('\nMini Grammar: version 1.1 with printing of the syntactic trees.\n\n'),
    write('WARNING: Please run dict/0 to consult the dictionary BEFORE the first run.\n'),
  quali_esempi,
  first_msg.

?-header.
